/*----- PROTECTED REGION ID(CCDSpectrometerClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        CCDSpectrometerClass.h
//
// description : Include for the CCDSpectrometer root class.
//               This class is the singleton class for
//                the CCDSpectrometer device class.
//               It contains all properties and methods which the
//               CCDSpectrometer requires only once e.g. the commands.
//
// project :     CCDSpectrometer
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef CCDSpectrometerClass_H
#define CCDSpectrometerClass_H

#include <tango.h>
#include "CCDSpectrometer.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CCDSpectrometerClass.h


namespace CCDSpectrometer_ns
{
/*----- PROTECTED REGION ID(CCDSpectrometerClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CCDSpectrometerClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute SyncMode class definition
class SyncModeAttrib: public Tango::Attr
{
public:
	SyncModeAttrib():Attr("SyncMode",
			Tango::DEV_LONG, Tango::READ_WRITE) {}
	~SyncModeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_SyncMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_SyncMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_SyncMode_allowed(ty);}
};

//	Attribute ExposureTime class definition
class ExposureTimeAttrib: public Tango::Attr
{
public:
	ExposureTimeAttrib():Attr("ExposureTime",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~ExposureTimeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_ExposureTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_ExposureTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_ExposureTime_allowed(ty);}
};

//	Attribute NoiseSubtraction class definition
class NoiseSubtractionAttrib: public Tango::Attr
{
public:
	NoiseSubtractionAttrib():Attr("NoiseSubtraction",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~NoiseSubtractionAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_NoiseSubtraction(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_NoiseSubtraction(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_NoiseSubtraction_allowed(ty);}
};

//	Attribute GaussFitEnable class definition
class GaussFitEnableAttrib: public Tango::Attr
{
public:
	GaussFitEnableAttrib():Attr("GaussFitEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~GaussFitEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_GaussFitEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_GaussFitEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_GaussFitEnable_allowed(ty);}
};

//	Attribute FWHMEnable class definition
class FWHMEnableAttrib: public Tango::Attr
{
public:
	FWHMEnableAttrib():Attr("FWHMEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~FWHMEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_FWHMEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_FWHMEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_FWHMEnable_allowed(ty);}
};

//	Attribute GaussFitCenter class definition
class GaussFitCenterAttrib: public Tango::Attr
{
public:
	GaussFitCenterAttrib():Attr("GaussFitCenter",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~GaussFitCenterAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_GaussFitCenter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_GaussFitCenter_allowed(ty);}
};

//	Attribute GaussFitWidth class definition
class GaussFitWidthAttrib: public Tango::Attr
{
public:
	GaussFitWidthAttrib():Attr("GaussFitWidth",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~GaussFitWidthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_GaussFitWidth(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_GaussFitWidth_allowed(ty);}
};

//	Attribute FWHMCenter class definition
class FWHMCenterAttrib: public Tango::Attr
{
public:
	FWHMCenterAttrib():Attr("FWHMCenter",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~FWHMCenterAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_FWHMCenter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_FWHMCenter_allowed(ty);}
};

//	Attribute FWHMWidth class definition
class FWHMWidthAttrib: public Tango::Attr
{
public:
	FWHMWidthAttrib():Attr("FWHMWidth",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~FWHMWidthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_FWHMWidth(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_FWHMWidth_allowed(ty);}
};

//	Attribute Center class definition
class CenterAttrib: public Tango::Attr
{
public:
	CenterAttrib():Attr("Center",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~CenterAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_Center(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_Center_allowed(ty);}
};

//	Attribute Width class definition
class WidthAttrib: public Tango::Attr
{
public:
	WidthAttrib():Attr("Width",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~WidthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_Width(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_Width_allowed(ty);}
};

//	Attribute FitType class definition
class FitTypeAttrib: public Tango::Attr
{
public:
	FitTypeAttrib():Attr("FitType",
			Tango::DEV_LONG, Tango::READ_WRITE) {}
	~FitTypeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_FitType(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_FitType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_FitType_allowed(ty);}
};

//	Attribute FWHMAvg class definition
class FWHMAvgAttrib: public Tango::Attr
{
public:
	FWHMAvgAttrib():Attr("FWHMAvg",
			Tango::DEV_LONG, Tango::READ_WRITE) {}
	~FWHMAvgAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_FWHMAvg(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_FWHMAvg(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_FWHMAvg_allowed(ty);}
};

//	Attribute NoiseLevel class definition
class NoiseLevelAttrib: public Tango::Attr
{
public:
	NoiseLevelAttrib():Attr("NoiseLevel",
			Tango::DEV_LONG, Tango::READ_WRITE) {}
	~NoiseLevelAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_NoiseLevel(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_NoiseLevel(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_NoiseLevel_allowed(ty);}
};

//	Attribute DataReferenceFile class definition
class DataReferenceFileAttrib: public Tango::Attr
{
public:
	DataReferenceFileAttrib():Attr("DataReferenceFile",
			Tango::DEV_STRING, Tango::READ_WRITE) {}
	~DataReferenceFileAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_DataReferenceFile(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_DataReferenceFile(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_DataReferenceFile_allowed(ty);}
};

//	Attribute AutoExposure class definition
class AutoExposureAttrib: public Tango::Attr
{
public:
	AutoExposureAttrib():Attr("AutoExposure",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~AutoExposureAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_AutoExposure(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_AutoExposure(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_AutoExposure_allowed(ty);}
};

//	Attribute RtMode class definition
class RtModeAttrib: public Tango::Attr
{
public:
	RtModeAttrib():Attr("RtMode",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~RtModeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_RtMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_RtMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_RtMode_allowed(ty);}
};

//	Attribute IntensityCalibrationEnable class definition
class IntensityCalibrationEnableAttrib: public Tango::Attr
{
public:
	IntensityCalibrationEnableAttrib():Attr("IntensityCalibrationEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~IntensityCalibrationEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_IntensityCalibrationEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_IntensityCalibrationEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_IntensityCalibrationEnable_allowed(ty);}
};

//	Attribute Area class definition
class AreaAttrib: public Tango::Attr
{
public:
	AreaAttrib():Attr("Area",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~AreaAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_Area(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_Area_allowed(ty);}
};

//	Attribute AreaRegion class definition
class AreaRegionAttrib: public Tango::Attr
{
public:
	AreaRegionAttrib():Attr("AreaRegion",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~AreaRegionAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_AreaRegion(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_AreaRegion(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_AreaRegion_allowed(ty);}
};

//	Attribute AreaEnable class definition
class AreaEnableAttrib: public Tango::Attr
{
public:
	AreaEnableAttrib():Attr("AreaEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~AreaEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_AreaEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_AreaEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_AreaEnable_allowed(ty);}
};

//	Attribute WidthCorrectionEnable class definition
class WidthCorrectionEnableAttrib: public Tango::Attr
{
public:
	WidthCorrectionEnableAttrib():Attr("WidthCorrectionEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~WidthCorrectionEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_WidthCorrectionEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_WidthCorrectionEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_WidthCorrectionEnable_allowed(ty);}
};

//	Attribute IncrSensitivity class definition
class IncrSensitivityAttrib: public Tango::Attr
{
public:
	IncrSensitivityAttrib():Attr("IncrSensitivity",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~IncrSensitivityAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_IncrSensitivity(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_IncrSensitivity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_IncrSensitivity_allowed(ty);}
};

//	Attribute Data class definition
class DataAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for Data attribute
	const static long X_DATA_SIZE = 4100;
	DataAttrib():SpectrumAttr("Data",
			Tango::DEV_DOUBLE, Tango::READ, DataAttrib::X_DATA_SIZE) {}
	~DataAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_Data_allowed(ty);}
};

//	Attribute NumPixels class definition
class NumPixelsAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for NumPixels attribute
	const static long X_DATA_SIZE = 2;
	NumPixelsAttrib():SpectrumAttr("NumPixels",
			Tango::DEV_LONG, Tango::READ, NumPixelsAttrib::X_DATA_SIZE) {}
	~NumPixelsAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_NumPixels(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_NumPixels_allowed(ty);}
};

//	Attribute RegionOfInterest class definition
class RegionOfInterestAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for RegionOfInterest attribute
	const static long X_DATA_SIZE = 2;
	RegionOfInterestAttrib():SpectrumAttr("RegionOfInterest",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, RegionOfInterestAttrib::X_DATA_SIZE) {}
	~RegionOfInterestAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_RegionOfInterest(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_RegionOfInterest(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_RegionOfInterest_allowed(ty);}
};

//	Attribute AnalysisRegion class definition
class AnalysisRegionAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for AnalysisRegion attribute
	const static long X_DATA_SIZE = 2;
	AnalysisRegionAttrib():SpectrumAttr("AnalysisRegion",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, AnalysisRegionAttrib::X_DATA_SIZE) {}
	~AnalysisRegionAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_AnalysisRegion(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_AnalysisRegion(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_AnalysisRegion_allowed(ty);}
};

//	Attribute GaussFit class definition
class GaussFitAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for GaussFit attribute
	const static long X_DATA_SIZE = 4;
	GaussFitAttrib():SpectrumAttr("GaussFit",
			Tango::DEV_DOUBLE, Tango::READ, GaussFitAttrib::X_DATA_SIZE) {}
	~GaussFitAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_GaussFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_GaussFit_allowed(ty);}
};

//	Attribute FWHM class definition
class FWHMAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for FWHM attribute
	const static long X_DATA_SIZE = 3;
	FWHMAttrib():SpectrumAttr("FWHM",
			Tango::DEV_DOUBLE, Tango::READ, FWHMAttrib::X_DATA_SIZE) {}
	~FWHMAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_FWHM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_FWHM_allowed(ty);}
};

//	Attribute GaussReference class definition
class GaussReferenceAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for GaussReference attribute
	const static long X_DATA_SIZE = 4;
	GaussReferenceAttrib():SpectrumAttr("GaussReference",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, GaussReferenceAttrib::X_DATA_SIZE) {}
	~GaussReferenceAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_GaussReference(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_GaussReference(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_GaussReference_allowed(ty);}
};

//	Attribute DataReference class definition
class DataReferenceAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for DataReference attribute
	const static long X_DATA_SIZE = 5000;
	DataReferenceAttrib():SpectrumAttr("DataReference",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, DataReferenceAttrib::X_DATA_SIZE) {}
	~DataReferenceAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_DataReference(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_DataReference(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_DataReference_allowed(ty);}
};

//	Attribute IntensityCalibration class definition
class IntensityCalibrationAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for IntensityCalibration attribute
	const static long X_DATA_SIZE = 5000;
	IntensityCalibrationAttrib():SpectrumAttr("IntensityCalibration",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, IntensityCalibrationAttrib::X_DATA_SIZE) {}
	~IntensityCalibrationAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_IntensityCalibration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->write_IntensityCalibration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_IntensityCalibration_allowed(ty);}
};

//	Attribute NoiseProfile class definition
class NoiseProfileAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for NoiseProfile attribute
	const static long X_DATA_SIZE = 5000;
	NoiseProfileAttrib():SpectrumAttr("NoiseProfile",
			Tango::DEV_DOUBLE, Tango::READ, NoiseProfileAttrib::X_DATA_SIZE) {}
	~NoiseProfileAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_NoiseProfile(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_NoiseProfile_allowed(ty);}
};

//	Attribute Wave class definition
class WaveAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for Wave attribute
	const static long X_DATA_SIZE = 5000;
	WaveAttrib():SpectrumAttr("Wave",
			Tango::DEV_DOUBLE, Tango::READ, WaveAttrib::X_DATA_SIZE) {}
	~WaveAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_Wave(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_Wave_allowed(ty);}
};

//	Attribute Lambda class definition
class LambdaAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for Lambda attribute
	const static long X_DATA_SIZE = 5000;
	LambdaAttrib():SpectrumAttr("Lambda",
			Tango::DEV_DOUBLE, Tango::READ, LambdaAttrib::X_DATA_SIZE) {}
	~LambdaAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CCDSpectrometer *>(dev))->read_Lambda(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CCDSpectrometer *>(dev))->is_Lambda_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Start class definition
class StartClass : public Tango::Command
{
public:
	StartClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	StartClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~StartClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_Start_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	StopClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~StopClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_Stop_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_Reset_allowed(any);}
};

//	Command StartSingle class definition
class StartSingleClass : public Tango::Command
{
public:
	StartSingleClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	StartSingleClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~StartSingleClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_StartSingle_allowed(any);}
};

//	Command StartContinuous class definition
class StartContinuousClass : public Tango::Command
{
public:
	StartContinuousClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	StartContinuousClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~StartContinuousClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_StartContinuous_allowed(any);}
};

//	Command GetLastData class definition
class GetLastDataClass : public Tango::Command
{
public:
	GetLastDataClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetLastDataClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetLastDataClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetLastData_allowed(any);}
};

//	Command AcquireNoise class definition
class AcquireNoiseClass : public Tango::Command
{
public:
	AcquireNoiseClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	AcquireNoiseClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~AcquireNoiseClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_AcquireNoise_allowed(any);}
};

//	Command SaveReferenceData class definition
class SaveReferenceDataClass : public Tango::Command
{
public:
	SaveReferenceDataClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	SaveReferenceDataClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~SaveReferenceDataClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_SaveReferenceData_allowed(any);}
};

//	Command GetData class definition
class GetDataClass : public Tango::Command
{
public:
	GetDataClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetDataClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetDataClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetData_allowed(any);}
};

//	Command GetGaussFitCenter class definition
class GetGaussFitCenterClass : public Tango::Command
{
public:
	GetGaussFitCenterClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetGaussFitCenterClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetGaussFitCenterClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetGaussFitCenter_allowed(any);}
};

//	Command GetGaussFitWidth class definition
class GetGaussFitWidthClass : public Tango::Command
{
public:
	GetGaussFitWidthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetGaussFitWidthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetGaussFitWidthClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetGaussFitWidth_allowed(any);}
};

//	Command GetFWHMCenter class definition
class GetFWHMCenterClass : public Tango::Command
{
public:
	GetFWHMCenterClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetFWHMCenterClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetFWHMCenterClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetFWHMCenter_allowed(any);}
};

//	Command GetFWHMWidth class definition
class GetFWHMWidthClass : public Tango::Command
{
public:
	GetFWHMWidthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetFWHMWidthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetFWHMWidthClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetFWHMWidth_allowed(any);}
};

//	Command ExportWavelength class definition
class ExportWavelengthClass : public Tango::Command
{
public:
	ExportWavelengthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ExportWavelengthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ExportWavelengthClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_ExportWavelength_allowed(any);}
};

//	Command GetArea class definition
class GetAreaClass : public Tango::Command
{
public:
	GetAreaClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetAreaClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetAreaClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetArea_allowed(any);}
};

//	Command GetWave class definition
class GetWaveClass : public Tango::Command
{
public:
	GetWaveClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetWaveClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetWaveClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetWave_allowed(any);}
};

//	Command GetLambda class definition
class GetLambdaClass : public Tango::Command
{
public:
	GetLambdaClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetLambdaClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetLambdaClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CCDSpectrometer *>(dev))->is_GetLambda_allowed(any);}
};


/**
 *	The CCDSpectrometerClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  CCDSpectrometerClass : public Tango::DeviceClass
#else
class CCDSpectrometerClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(CCDSpectrometerClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometerClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static CCDSpectrometerClass *init(const char *);
		static CCDSpectrometerClass *instance();
		~CCDSpectrometerClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		CCDSpectrometerClass(std::string &);
		static CCDSpectrometerClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	CCDSpectrometer_H
