/*----- PROTECTED REGION ID(CCDSpectrometerStateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        CCDSpectrometerStateMachine.cpp
//
// description : State machine file for the CCDSpectrometer class
//
// project :     CCDSpectrometer
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "CCDSpectrometer.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::CCDSpectrometerStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace CCDSpectrometer_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_SyncMode_allowed()
 *	Description: Execution allowed for SyncMode attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_SyncMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SyncMode attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::SyncModeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::SyncModeStateAllowed_WRITE

	//	Not any excluded states for SyncMode attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::SyncModeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::SyncModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_ExposureTime_allowed()
 *	Description: Execution allowed for ExposureTime attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_ExposureTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureTime attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::ExposureTimeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::ExposureTimeStateAllowed_WRITE

	//	Not any excluded states for ExposureTime attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::ExposureTimeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::ExposureTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_NoiseSubtraction_allowed()
 *	Description: Execution allowed for NoiseSubtraction attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_NoiseSubtraction_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for NoiseSubtraction attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::NoiseSubtractionStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::NoiseSubtractionStateAllowed_WRITE

	//	Not any excluded states for NoiseSubtraction attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::NoiseSubtractionStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::NoiseSubtractionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GaussFitEnable_allowed()
 *	Description: Execution allowed for GaussFitEnable attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GaussFitEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GaussFitEnable attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GaussFitEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GaussFitEnableStateAllowed_WRITE

	//	Not any excluded states for GaussFitEnable attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GaussFitEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GaussFitEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_FWHMEnable_allowed()
 *	Description: Execution allowed for FWHMEnable attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_FWHMEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FWHMEnable attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FWHMEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FWHMEnableStateAllowed_WRITE

	//	Not any excluded states for FWHMEnable attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FWHMEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FWHMEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GaussFitCenter_allowed()
 *	Description: Execution allowed for GaussFitCenter attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GaussFitCenter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for GaussFitCenter attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GaussFitCenterStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GaussFitCenterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GaussFitWidth_allowed()
 *	Description: Execution allowed for GaussFitWidth attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GaussFitWidth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for GaussFitWidth attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GaussFitWidthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GaussFitWidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_FWHMCenter_allowed()
 *	Description: Execution allowed for FWHMCenter attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_FWHMCenter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FWHMCenter attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FWHMCenterStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FWHMCenterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_FWHMWidth_allowed()
 *	Description: Execution allowed for FWHMWidth attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_FWHMWidth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FWHMWidth attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FWHMWidthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FWHMWidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Center_allowed()
 *	Description: Execution allowed for Center attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Center_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Center attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::CenterStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::CenterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Width_allowed()
 *	Description: Execution allowed for Width attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Width_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Width attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::WidthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::WidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_FitType_allowed()
 *	Description: Execution allowed for FitType attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_FitType_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FitType attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FitTypeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FitTypeStateAllowed_WRITE

	//	Not any excluded states for FitType attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FitTypeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FitTypeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_FWHMAvg_allowed()
 *	Description: Execution allowed for FWHMAvg attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_FWHMAvg_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FWHMAvg attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FWHMAvgStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FWHMAvgStateAllowed_WRITE

	//	Not any excluded states for FWHMAvg attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FWHMAvgStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FWHMAvgStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_NoiseLevel_allowed()
 *	Description: Execution allowed for NoiseLevel attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_NoiseLevel_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for NoiseLevel attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::NoiseLevelStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::NoiseLevelStateAllowed_WRITE

	//	Not any excluded states for NoiseLevel attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::NoiseLevelStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::NoiseLevelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_DataReferenceFile_allowed()
 *	Description: Execution allowed for DataReferenceFile attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_DataReferenceFile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DataReferenceFile attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::DataReferenceFileStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::DataReferenceFileStateAllowed_WRITE

	//	Not any excluded states for DataReferenceFile attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::DataReferenceFileStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::DataReferenceFileStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_AutoExposure_allowed()
 *	Description: Execution allowed for AutoExposure attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_AutoExposure_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoExposure attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AutoExposureStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AutoExposureStateAllowed_WRITE

	//	Not any excluded states for AutoExposure attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AutoExposureStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AutoExposureStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_RtMode_allowed()
 *	Description: Execution allowed for RtMode attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_RtMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RtMode attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::RtModeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::RtModeStateAllowed_WRITE

	//	Not any excluded states for RtMode attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::RtModeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::RtModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_IntensityCalibrationEnable_allowed()
 *	Description: Execution allowed for IntensityCalibrationEnable attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_IntensityCalibrationEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IntensityCalibrationEnable attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::IntensityCalibrationEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::IntensityCalibrationEnableStateAllowed_WRITE

	//	Not any excluded states for IntensityCalibrationEnable attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::IntensityCalibrationEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::IntensityCalibrationEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Area_allowed()
 *	Description: Execution allowed for Area attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Area_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Area attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AreaStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AreaStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_AreaRegion_allowed()
 *	Description: Execution allowed for AreaRegion attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_AreaRegion_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AreaRegion attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AreaRegionStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AreaRegionStateAllowed_WRITE

	//	Not any excluded states for AreaRegion attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AreaRegionStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AreaRegionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_AreaEnable_allowed()
 *	Description: Execution allowed for AreaEnable attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_AreaEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AreaEnable attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AreaEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AreaEnableStateAllowed_WRITE

	//	Not any excluded states for AreaEnable attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AreaEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AreaEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_WidthCorrectionEnable_allowed()
 *	Description: Execution allowed for WidthCorrectionEnable attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_WidthCorrectionEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for WidthCorrectionEnable attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::WidthCorrectionEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::WidthCorrectionEnableStateAllowed_WRITE

	//	Not any excluded states for WidthCorrectionEnable attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::WidthCorrectionEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::WidthCorrectionEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_IncrSensitivity_allowed()
 *	Description: Execution allowed for IncrSensitivity attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_IncrSensitivity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IncrSensitivity attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::IncrSensitivityStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::IncrSensitivityStateAllowed_WRITE

	//	Not any excluded states for IncrSensitivity attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::IncrSensitivityStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::IncrSensitivityStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Data_allowed()
 *	Description: Execution allowed for Data attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Data_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Data attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::DataStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::DataStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_NumPixels_allowed()
 *	Description: Execution allowed for NumPixels attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_NumPixels_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for NumPixels attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::NumPixelsStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::NumPixelsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_RegionOfInterest_allowed()
 *	Description: Execution allowed for RegionOfInterest attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_RegionOfInterest_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RegionOfInterest attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::RegionOfInterestStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::RegionOfInterestStateAllowed_WRITE

	//	Not any excluded states for RegionOfInterest attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::RegionOfInterestStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::RegionOfInterestStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_AnalysisRegion_allowed()
 *	Description: Execution allowed for AnalysisRegion attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_AnalysisRegion_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AnalysisRegion attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AnalysisRegionStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AnalysisRegionStateAllowed_WRITE

	//	Not any excluded states for AnalysisRegion attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AnalysisRegionStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AnalysisRegionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GaussFit_allowed()
 *	Description: Execution allowed for GaussFit attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GaussFit_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for GaussFit attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GaussFitStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GaussFitStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_FWHM_allowed()
 *	Description: Execution allowed for FWHM attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_FWHM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FWHM attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::FWHMStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::FWHMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GaussReference_allowed()
 *	Description: Execution allowed for GaussReference attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GaussReference_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GaussReference attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GaussReferenceStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GaussReferenceStateAllowed_WRITE

	//	Not any excluded states for GaussReference attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GaussReferenceStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GaussReferenceStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_DataReference_allowed()
 *	Description: Execution allowed for DataReference attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_DataReference_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DataReference attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::DataReferenceStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::DataReferenceStateAllowed_WRITE

	//	Not any excluded states for DataReference attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::DataReferenceStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::DataReferenceStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_IntensityCalibration_allowed()
 *	Description: Execution allowed for IntensityCalibration attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_IntensityCalibration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IntensityCalibration attribute in Write access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::IntensityCalibrationStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::IntensityCalibrationStateAllowed_WRITE

	//	Not any excluded states for IntensityCalibration attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::IntensityCalibrationStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::IntensityCalibrationStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_NoiseProfile_allowed()
 *	Description: Execution allowed for NoiseProfile attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_NoiseProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for NoiseProfile attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::NoiseProfileStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::NoiseProfileStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Wave_allowed()
 *	Description: Execution allowed for Wave attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Wave_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Wave attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::WaveStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::WaveStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Lambda_allowed()
 *	Description: Execution allowed for Lambda attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Lambda_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Lambda attribute in read access.
	/*----- PROTECTED REGION ID(CCDSpectrometer::LambdaStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::LambdaStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Start_allowed()
 *	Description: Execution allowed for Start attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Start_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Start command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::StartStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::StartStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Stop_allowed()
 *	Description: Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::StopStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_Reset_allowed()
 *	Description: Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::ResetStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_StartSingle_allowed()
 *	Description: Execution allowed for StartSingle attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_StartSingle_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StartSingle command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::StartSingleStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::StartSingleStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_StartContinuous_allowed()
 *	Description: Execution allowed for StartContinuous attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_StartContinuous_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StartContinuous command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::StartContinuousStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::StartContinuousStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetLastData_allowed()
 *	Description: Execution allowed for GetLastData attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetLastData_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetLastData command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetLastDataStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetLastDataStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_AcquireNoise_allowed()
 *	Description: Execution allowed for AcquireNoise attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_AcquireNoise_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AcquireNoise command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::AcquireNoiseStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::AcquireNoiseStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_SaveReferenceData_allowed()
 *	Description: Execution allowed for SaveReferenceData attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_SaveReferenceData_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SaveReferenceData command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::SaveReferenceDataStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::SaveReferenceDataStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetData_allowed()
 *	Description: Execution allowed for GetData attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetData_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetData command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetDataStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetDataStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetGaussFitCenter_allowed()
 *	Description: Execution allowed for GetGaussFitCenter attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetGaussFitCenter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetGaussFitCenter command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetGaussFitCenterStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetGaussFitCenterStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetGaussFitWidth_allowed()
 *	Description: Execution allowed for GetGaussFitWidth attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetGaussFitWidth_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetGaussFitWidth command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetGaussFitWidthStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetGaussFitWidthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetFWHMCenter_allowed()
 *	Description: Execution allowed for GetFWHMCenter attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetFWHMCenter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetFWHMCenter command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetFWHMCenterStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetFWHMCenterStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetFWHMWidth_allowed()
 *	Description: Execution allowed for GetFWHMWidth attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetFWHMWidth_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetFWHMWidth command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetFWHMWidthStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetFWHMWidthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_ExportWavelength_allowed()
 *	Description: Execution allowed for ExportWavelength attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_ExportWavelength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ExportWavelength command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::ExportWavelengthStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::ExportWavelengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetArea_allowed()
 *	Description: Execution allowed for GetArea attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetArea_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetArea command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetAreaStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetAreaStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetWave_allowed()
 *	Description: Execution allowed for GetWave attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetWave_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetWave command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetWaveStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetWaveStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : CCDSpectrometer::is_GetLambda_allowed()
 *	Description: Execution allowed for GetLambda attribute
 */
//--------------------------------------------------------
bool CCDSpectrometer::is_GetLambda_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetLambda command.
	/*----- PROTECTED REGION ID(CCDSpectrometer::GetLambdaStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::GetLambdaStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(CCDSpectrometer::CCDSpectrometerStateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CCDSpectrometer::CCDSpectrometerStateAllowed.AdditionalMethods

}	//	End of namespace
